Bug 894589

Summary: Review Request: coin-or-Alps - COIN-OR High-Performance Parallel Search Framework
Product: [Fedora] Fedora Reporter: Paulo Andrade <paulo.cesar.pereira.de.andrade>
Component: Package ReviewAssignee: Antonio Trande <anto.trande>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: anto.trande, package-review
Target Milestone: ---Flags: anto.trande: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: coin-or-Cgl-0.58.5-1.fc20 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2014-04-15 11:54:16 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 894585, 894586, 894587, 894588    
Bug Blocks: 894591, 894596, 894602    

Description Paulo Andrade 2013-01-12 09:32:26 EST
Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps-1.4.2-3.fc19.src.rpm
Description: CHiPPS is the COIN-OR High-Performance Parallel Search Framework, a framework
for implementing parallel algorithms based on tree search. The current CHiPPS
architecture consists of three layers. The Abstract Library for Parallel Search
(ALPS) is the base layer of a hierarchy consisting of implementations of
various tree search algorithms for specific problem types. The Branch,
Constrain, and Price Software (BiCePS) is a data management layer built on
top of ALPS for implementing relaxation-based branch and bound algorithms.
The BiCePS Linear Integer Solver (BLIS) is a concretization of the BiCePS
layer for solving mixed-integer linear programs. ALPS, BiCePS, and BLIS
are sub-repostories of the CHiPPS Subversion repository.
Fedora Account System Username: pcpa
Comment 1 Paulo Andrade 2013-01-12 09:33:27 EST
Note that the tarball is remade due to:
+ Data files without a clean license. licensecheck does not trigger
  it because they are small test case files, but a not so small
  collection, and authorship information was lost.
+ ThirdParty directory, that points to, but has no contents, of
  non free code (usually source code open but needs some kind of
  paid license to be able to use).
+ Most coin-or projects bundle other coin-or projects that are
  dependencies. If tarballs are not repackaged, %build will remove
  the bundled dependencies.

I made the original package back in september and was talking from
time to time to upstream about the issues above. There should be
at some point in the near future a new release with bundled dependencies
and code that cannot be redistributed removed from tarballs. There is
also a way to get "clean" tarballs from coin-or trac, but for the
review request I did choose the most common method in Fedora for
these conditions.
Comment 2 Paulo Andrade 2013-01-14 16:35:09 EST
Update:

- Update to run make check (#894610#c4).

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps-1.4.2-4.fc19.src.rpm
Comment 3 Paulo Andrade 2014-03-08 07:22:15 EST
After quite some time and significant communication with upstream
a new release that should fix all build issues on the tarball
without bundled subprojects is available.

Update:

- Update to latest upstream release.

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps-1.4.10-1.fc21.src.rpm
Comment 4 Antonio Trande 2014-03-08 11:35:16 EST
Hi Paulo.

The compilation fails. There should be a missing BR package (bzip2-devel?).

"...
/usr/bin/ld: cannot find -lbz2 "
Comment 5 Paulo Andrade 2014-03-08 14:30:09 EST
Hi Antonio.

Sorry for the problem, now properly pre checked with
fedora-review -r -n coin-or-Alps

Update:

- Add missing bzip2-devel and texlive-epstopdf build requires.

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps-1.4.10-2.fc21.src.rpm
Comment 6 Antonio Trande 2014-03-08 15:42:37 EST
- /usr/include/coin has still not any owner.
See your comment https://bugzilla.redhat.com/show_bug.cgi?id=894586#c7

- I think, -doc sub-package can be independent by main package.

- Please, fix the parallel make %{?_smp_mflags} macro


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 79 files have unknown license. Detailed output of
     licensecheck in /home/sagitter/894589-coin-or-Alps/licensecheck.txt
[?]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/include/coin
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/include/coin
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in coin-or-
     Alps-doc
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: coin-or-Alps-1.4.10-2.fc21.x86_64.rpm
          coin-or-Alps-devel-1.4.10-2.fc21.x86_64.rpm
          coin-or-Alps-doc-1.4.10-2.fc21.noarch.rpm
          coin-or-Alps-1.4.10-2.fc21.src.rpm
coin-or-Alps.x86_64: W: spelling-error %description -l en_US concretization -> containerization, concretion, democratization
coin-or-Alps.x86_64: W: spelling-error %description -l en_US repostories -> repositories, repertories, depositories
coin-or-Alps-devel.x86_64: W: no-documentation
coin-or-Alps.src: W: spelling-error %description -l en_US concretization -> containerization, concretion, democratization
coin-or-Alps.src: W: spelling-error %description -l en_US repostories -> repositories, repertories, depositories
4 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint coin-or-Alps coin-or-Alps-devel coin-or-Alps-doc
coin-or-Alps.x86_64: W: spelling-error %description -l en_US concretization -> containerization, concretion, democratization
coin-or-Alps.x86_64: W: spelling-error %description -l en_US repostories -> repositories, repertories, depositories
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinError::printErrors_
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessageHandler::message(int, CoinMessages const&)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessages::CoinMessages(CoinMessages const&)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessages::CoinMessages(int)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessageHandler::operator<<(double)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessages::operator=(CoinMessages const&)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessageHandler::operator<<(CoinMessageMarker)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessageHandler::operator<<(int)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessages::addMessage(int, CoinOneMessage const&)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessageHandler::CoinMessageHandler()
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinOneMessage::CoinOneMessage(int, char, char const*)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessages::~CoinMessages()
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinOneMessage::~CoinOneMessage()
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessages::~CoinMessages()
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessageHandler::operator<<(char const*)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessageHandler::setLogLevel(int)
coin-or-Alps.x86_64: W: undefined-non-weak-symbol /usr/lib64/libAlps.so.3.4.10 CoinMessages::CoinMessages(int)
coin-or-Alps.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libAlps.so.3.4.10 /lib64/libm.so.6
coin-or-Alps-devel.x86_64: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 21 warnings.
# echo 'rpmlint-done:'



Requires
--------
coin-or-Alps (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    rtld(GNU_HASH)

coin-or-Alps-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    coin-or-Alps(x86-64)
    libAlps.so.3()(64bit)
    pkgconfig(coinutils)

coin-or-Alps-doc (rpmlib, GLIBC filtered):
    coin-or-Alps



Provides
--------
coin-or-Alps:
    coin-or-Alps
    coin-or-Alps(x86-64)
    libAlps.so.3()(64bit)

coin-or-Alps-devel:
    coin-or-Alps-devel
    coin-or-Alps-devel(x86-64)
    pkgconfig(alps)

coin-or-Alps-doc:
    coin-or-Alps-doc



Source checksums
----------------
http://www.coin-or.org/download/pkgsource/CHiPPS/Alps-1.4.10.tgz :
  CHECKSUM(SHA256) this package     : e24fff20baee05161d21289c1279bac7629212115121d204637d34a6331c4336
  CHECKSUM(SHA256) upstream package : e24fff20baee05161d21289c1279bac7629212115121d204637d34a6331c4336


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 894589
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG
Comment 7 Paulo Andrade 2014-03-08 16:24:05 EST
(In reply to Antonio Trande from comment #6)
> - /usr/include/coin has still not any owner.
> See your comment https://bugzilla.redhat.com/show_bug.cgi?id=894586#c7

  It has an owner, the problem should be that the -devel
requires does not explicitly require the owner of the
directory, what should be fixed now.

$ rpm -qf /usr/include/coin
coin-or-CoinUtils-devel-2.9.7-3.fc21.x86_64

> - I think, -doc sub-package can be independent by main package.

  I am following an earlier advice from Jerry James, because
doxygen documentation is (frequently) quite large, and is better
not being owned by the main or devel packages on those cases.

> - Please, fix the parallel make %{?_smp_mflags} macro

  Correct this case, and I also made a review in all of
my packages, found and corrected, a few other cases I
misspelled it.

Update:

- Correct misspelling of _smp_mflags.
- Make devel subpackage require coin-or-CoinUtils-devel.

Spec URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps.spec
SRPM URL: http://pcpa.fedorapeople.org/coin-or/coin-or-Alps-1.4.10-3.fc21.src.rpm
Comment 8 Antonio Trande 2014-03-08 17:11:27 EST
(In reply to Paulo Andrade from comment #7)
> (In reply to Antonio Trande from comment #6)
> > - /usr/include/coin has still not any owner.
> > See your comment https://bugzilla.redhat.com/show_bug.cgi?id=894586#c7
> 
>   It has an owner, the problem should be that the -devel
> requires does not explicitly require the owner of the
> directory, what should be fixed now.
> 
> $ rpm -qf /usr/include/coin
> coin-or-CoinUtils-devel-2.9.7-3.fc21.x86_64

coin-or-CoinUtils-devel owns that directory only in the package f21; I checked in Fedora 20 (2.9.0-3) instead. :P

> 
> > - I think, -doc sub-package can be independent by main package.
> 
>   I am following an earlier advice from Jerry James, because
> doxygen documentation is (frequently) quite large, and is better
> not being owned by the main or devel packages on those cases.

I agree; I mean -doc may even not require '%{name} = %{version}-%{release}'.
Comment 9 Paulo Andrade 2014-03-08 19:04:20 EST
(In reply to Antonio Trande from comment #8)
> (In reply to Paulo Andrade from comment #7)
> > (In reply to Antonio Trande from comment #6)
> > > - /usr/include/coin has still not any owner.
> > > See your comment https://bugzilla.redhat.com/show_bug.cgi?id=894586#c7
> > 
> >   It has an owner, the problem should be that the -devel
> > requires does not explicitly require the owner of the
> > directory, what should be fixed now.
> > 
> > $ rpm -qf /usr/include/coin
> > coin-or-CoinUtils-devel-2.9.7-3.fc21.x86_64
> 
> coin-or-CoinUtils-devel owns that directory only in the package f21; I
> checked in Fedora 20 (2.9.0-3) instead. :P

  I can make an update. Just that I am still half way in
adding coin-or-* projects/packages to Fedora, so I did not
bother earlier to update f20, sorry :-(

> > > - I think, -doc sub-package can be independent by main package.
> > 
> >   I am following an earlier advice from Jerry James, because
> > doxygen documentation is (frequently) quite large, and is better
> > not being owned by the main or devel packages on those cases.
> 
> I agree; I mean -doc may even not require '%{name} = %{version}-%{release}'.

  That is something to think about :-) but usually if someone
wants documentation, also wants devel and runtime.
Comment 10 Antonio Trande 2014-03-09 07:16:50 EDT
Package approved.
Comment 11 Paulo Andrade 2014-03-09 13:48:05 EDT
New Package SCM Request
=======================
Package Name: coin-or-Alps
Short Description: COIN-OR High-Performance Parallel Search Framework
Owners: pcpa
Branches: f20
InitialCC:
Comment 12 Gwyn Ciesla 2014-03-10 07:54:16 EDT
Git done (by process-git-requests).
Comment 13 Fedora Update System 2014-04-04 19:47:49 EDT
coin-or-Cgl-0.58.5-1.fc20,coin-or-Alps-1.4.10-3.fc20,coin-or-Bcps-0.93.12-2.fc20,coin-or-Blis-0.93.11-2.fc20,coin-or-Cbc-2.8.9-1.fc20,coin-or-DyLP-1.9.4-1.fc20,coin-or-Vol-1.4.4-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/coin-or-Cgl-0.58.5-1.fc20,coin-or-Alps-1.4.10-3.fc20,coin-or-Bcps-0.93.12-2.fc20,coin-or-Blis-0.93.11-2.fc20,coin-or-Cbc-2.8.9-1.fc20,coin-or-DyLP-1.9.4-1.fc20,coin-or-Vol-1.4.4-1.fc20
Comment 14 Fedora Update System 2014-04-05 22:33:25 EDT
coin-or-Cgl-0.58.5-1.fc20, coin-or-Alps-1.4.10-3.fc20, coin-or-Bcps-0.93.12-2.fc20, coin-or-Blis-0.93.11-2.fc20, coin-or-Cbc-2.8.9-1.fc20, coin-or-DyLP-1.9.4-1.fc20, coin-or-Vol-1.4.4-1.fc20 has been pushed to the Fedora 20 testing repository.
Comment 15 Fedora Update System 2014-04-15 11:54:16 EDT
coin-or-Cgl-0.58.5-1.fc20, coin-or-Alps-1.4.10-3.fc20, coin-or-Bcps-0.93.12-2.fc20, coin-or-Blis-0.93.11-2.fc20, coin-or-Cbc-2.8.9-1.fc20, coin-or-DyLP-1.9.4-1.fc20, coin-or-Vol-1.4.4-1.fc20 has been pushed to the Fedora 20 stable repository.